<template>
  <v-col>
    <v-col class="mb-2">
      <v-row align="end">
        <v-btn v-if="$vuetify.breakpoint.smAndUp && !seleccionable" color="accent" @click="abrirForm">
          <v-icon left>
            fal fa-user-plus
          </v-icon>
          Nuevo veterinario
        </v-btn>
        <v-spacer v-if="$vuetify.breakpoint.smAndUp" />
        <v-text-field
          v-model="search"
          append-icon="fal fa-search"
          label="Buscar"
          single-line
          color="accent"
          hide-details
          :style="$vuetify.breakpoint.smAndDown ? 'display: block' : 'max-width: 40vh'"
        />
      </v-row>
    </v-col>
    <v-data-table
      ref="tabla"
      v-model="selected"
      :items-per-page="10"
      :headers="seleccionable ? headersSeleccionable : headers"
      :items="veterinarios"
      :search="search"
      class="elevation-1"
      item-key="idveterinarios"
      :show-select="seleccionable"
      single-select
      @item-selected="enviarSeleccionado()"
    >
      <template #[`item.action`]="{ item }">
        <v-icon
          small
          class="mr-2 fal fa-edit"
          @click="modificarVeterinario(item)"
        />
        <v-icon
          small
          class="fal fa-trash-alt"
          @click="eliminarVeterinario(item.idveterinarios)"
        />
      </template>
    </v-data-table>
  </v-col>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import { Veterinario } from '~/core/models/veterinario'
import AppToast from '~/core/utils/AppToast'
import { VeterinariosStore } from '~/store/VeterinariosStore'

@Component
export default class listaVeterinarios extends Vue {
  @Ref() tabla;
  @Prop({ default: false }) seleccionable!:boolean;
  @Prop({ default: null }) veterinarioSeleccionado!:Veterinario;

  search = '';
  selected:Veterinario[] = [];

  headersSeleccionable = [
    { text: 'Seleccione', align: 'left', value: 'data-table-select' },
    { text: 'Nombre', align: 'left', value: 'name' },
    { text: 'DNI', align: 'left', value: 'dni' },
    { text: 'Teléfono', align: 'left', value: 'telefono' },
    { value: 'icons', align: 'right', sortable: false, width: 80 }

  ];

  headers = [
    { text: 'Nombre', align: 'left', value: 'name' },
    { text: 'DNI', align: 'left', value: 'dni' },
    { text: 'Teléfono', align: 'left', value: 'telefono' },
    { value: 'action', align: 'right', sortable: false }
  ];

  get veterinarios ():Veterinario[] {
    return VeterinariosStore.listaVeterinarios
  }

  mounted () {
    if (this.veterinarioSeleccionado === null) {
      this.selected = []
    } else { this.selected.push(this.veterinarioSeleccionado) }
  }

  modificarVeterinario (val) {
    this.$emit('onEdit', val)
  }

  eliminarVeterinario (id:number) {
    this.$confirm('¿Está seguro?').then(async (res) => {
      if (res) {
        await VeterinariosStore.eliminarVeterinario(id)
        AppToast.info('Veterinario eliminado')
      }
    }).catch()
  }

  enviarSeleccionado () {
    setTimeout(() => {
      this.$emit('selectedVeterinario', this.selected[0])
    }, 300)
  }

  abrirForm () {
    this.$emit('onAbrir')
  }
}
</script>

<style lang="scss">

</style>
